require 'socket'
require 'thread'
require 'timeout'

tout_base = 1.0
tout_max  = 60.0
tout_rate = 1.4

host = if ARGV[0] then ARGV[0] else 'localhost' end
port = if ARGV[1] then ARGV[1] else 'echo' end
sock = UDPSocket.open

msg_ID = 0
rcv_ID = 0
msgbuf = []
rcvbuf = []
m_msg = Mutex.new  # Хå Mutex
m_rcv = Mutex.new  # å Mutex

Thread.abort_on_exception = true

# å1 : ϼա
th_input = Thread.start {
  while msg = STDIN.gets
    m_msg.synchronize {
      msgbuf << msg
    }
    sock.send(msg_ID.to_s + ':' + msg, 0, host, port)
    msg_ID += 1
  end
}

# å2 : ѥåȼ
th_recv = Thread.start {
  loop do
    data = nil
    begin
      timeout(tout_max) {
        data, = sock.recvfrom(1024)
      }
    rescue
      retry if th_input.alive?
      raise if th_print.alive?
      break
    end
    data =~ /^(\d+):/
    id = $1.to_i
    msg = $'
    m_rcv.synchronize { 
      if id >= rcv_ID && !rcvbuf[id - rcv_ID]
        rcvbuf[id - rcv_ID] = msg
      end
    }
  end
}

# å3 : Хå
th_print = Thread.start {
  loop do
    # ̤˼ѤߤΥåν
    while rcvbuf[0]
      m_msg.synchronize {
        msgbuf.shift
      }
      m_rcv.synchronize {
        print 'Msg#' + rcv_ID.to_s + ':' + rcvbuf.shift
        rcv_ID += 1
      }
    end
    next unless rcv_ID < msg_ID

    # åκ
    tout = tout_base
    begin
      timeout(tout) {
        loop do
          break if rcvbuf[0]
        end
      }
    rescue TimeoutError
      sock.send(rcv_ID.to_s + ':' + msgbuf[0], 0, host, port)
      tout = tout * tout_rate
      if tout >= tout_max
        th_input.kill
        raise
      end
      retry
    end
  end
}

# Ϥ̵ʤΤԤ
th_input.join

# ĤॢȤޤԤ
while rcv_ID < msg_ID
  break unless th_recv.alive?
  break unless th_print.alive?
end

th_recv.kill  if th_recv.alive?
th_print.kill if th_print.alive?

sock.close
